local BaikCore = LibStub("AceAddon-3.0"):GetAddon("BaikCore")

-- Add Module to BaikCore
local Hook = {}
BaikCore.Hook = Hook

-- Hook API
function Hook:EnsureHook(hookModule, obj, method, handler, secure)
    local isHooked = hookModule:IsHooked(obj, method)
    if not isHooked then
        hookModule:Hook(obj, method, handler, secure)
    end
end

function Hook:EnsureHookScript(hookModule, frame, method, handle)
    local isHooked = hookModule:IsHooked(frame, method)
    if not isHooked then
        hookModule:HookScript(frame, method, handle)
    end
end

function Hook:EnsureRawHook(hookModule, obj, method, handler, secure)
    local isHooked = hookModule:IsHooked(obj, method)
    if not isHooked then
        hookModule:RawHook(obj, method, handler, secure)
    end
end

function Hook:EnsureSecureHook(hookModule, obj, method, handler)
    local isHooked = hookModule:IsHooked(obj, method)
    if not isHooked then
        hookModule:SecureHook(obj, method, handler)
    end
end

function Hook:EnsureSecureHookScript(hookModule, frame, script, handler)
    local isHooked = hookModule:IsHooked(frame, method)
    if not isHooked then
        hookModule:SecureHookScript(frame, script, handler)
    end
end

function Hook:EnsureNoOp(hookModule, obj, method, secure)
    local isHooked = hookModule:IsHooked(obj, method)
    if not isHooked then
        hookModule:RawHook(obj, method, function(...) end, secure)
    end
end

function Hook:EnsureUnhook(hookModule, obj, method)
    local isHooked = hookModule:IsHooked(obj, method)
    if isHooked then
        hookModule:Unhook(obj, method)
    end
end

